import _taggedTemplateLiteralLoose from "@babel/runtime/helpers/esm/taggedTemplateLiteralLoose";
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17, _templateObject18, _templateObject19, _templateObject20, _templateObject21, _templateObject22, _templateObject23, _templateObject24;
import { css, memoizeStyle, prefix } from "../../../lib/theming/Emotion";
import { boxWrapperSizeMixin, checkboxSizeMixin } from "../Checkbox.mixins";
export var globalClasses = prefix('checkbox')({
  box: 'box'
});
export var styles = memoizeStyle({
  root: function root(t) {
    return css(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["\n      display: inline-flex;\n      align-items: baseline;\n      cursor: pointer;\n      position: relative;\n\n      &::before {\n        // non-breaking space.\n        // makes a correct space for absolutely positioned box,\n        // and also height and baseline for checkbox without caption.\n        content: '\\00A0';\n        display: inline-block;\n        flex: 0 0 auto;\n      }\n\n      .", " {\n        transition:\n          background ", " ", ",\n          box-shadow ", " ", ";\n      }\n\n      &:hover .", " {\n        background: ", ";\n        box-shadow: ", ";\n      }\n\n      &:active .", " {\n        box-shadow: ", ";\n        background: ", ";\n      }\n    "], ["\n      display: inline-flex;\n      align-items: baseline;\n      cursor: pointer;\n      position: relative;\n\n      &::before {\n        // non-breaking space.\n        // makes a correct space for absolutely positioned box,\n        // and also height and baseline for checkbox without caption.\n        content: '\\\\00A0';\n        display: inline-block;\n        flex: 0 0 auto;\n      }\n\n      .", " {\n        transition:\n          background ", " ", ",\n          box-shadow ", " ", ";\n      }\n\n      &:hover .", " {\n        background: ", ";\n        box-shadow: ", ";\n      }\n\n      &:active .", " {\n        box-shadow: ", ";\n        background: ", ";\n      }\n    "])), globalClasses.box, t.transitionDuration, t.transitionTimingFunction, t.transitionDuration, t.transitionTimingFunction, globalClasses.box, t.checkboxHoverBg, t.checkboxShadowHover, globalClasses.box, t.checkboxShadowActive, t.checkboxActiveBg);
  },
  rootSmall: function rootSmall(t) {
    return css(_templateObject2 || (_templateObject2 = _taggedTemplateLiteralLoose(["\n      ", ";\n    "])), checkboxSizeMixin(t.checkboxFontSizeSmall, t.checkboxLineHeightSmall, t.checkboxPaddingYSmall, t.checkboxBoxSizeSmall, t.checkboxPaddingXSmall));
  },
  rootMedium: function rootMedium(t) {
    return css(_templateObject3 || (_templateObject3 = _taggedTemplateLiteralLoose(["\n      ", ";\n    "])), checkboxSizeMixin(t.checkboxFontSizeMedium, t.checkboxLineHeightMedium, t.checkboxPaddingYMedium, t.checkboxBoxSizeMedium, t.checkboxPaddingXMedium));
  },
  rootLarge: function rootLarge(t) {
    return css(_templateObject4 || (_templateObject4 = _taggedTemplateLiteralLoose(["\n      ", ";\n    "])), checkboxSizeMixin(t.checkboxFontSizeLarge, t.checkboxLineHeightLarge, t.checkboxPaddingYLarge, t.checkboxBoxSizeLarge, t.checkboxPaddingXLarge));
  },
  rootDisableTextSelect: function rootDisableTextSelect() {
    return css(_templateObject5 || (_templateObject5 = _taggedTemplateLiteralLoose(["\n      user-select: none;\n    "])));
  },
  rootChecked: function rootChecked(t) {
    return css(_templateObject6 || (_templateObject6 = _taggedTemplateLiteralLoose(["\n      &:hover .", " {\n        box-shadow: ", ";\n        background: ", ";\n      }\n\n      &:active .", " {\n        background: ", ";\n        box-shadow: ", ";\n      }\n    "])), globalClasses.box, t.checkboxCheckedHoverShadow, t.checkboxCheckedHoverBg, globalClasses.box, t.checkboxCheckedActiveBg, t.checkboxCheckedActiveShadow);
  },
  rootFallback: function rootFallback() {
    return css(_templateObject7 || (_templateObject7 = _taggedTemplateLiteralLoose(["\n      display: inline-table;\n\n      & > * {\n        // fix root's :active state in IE11 that gets blocked by nested elements\n        pointer-events: none;\n      }\n    "])));
  },
  rootWrapperIE11: function rootWrapperIE11() {
    return css(_templateObject8 || (_templateObject8 = _taggedTemplateLiteralLoose(["\n      display: inline;\n    "])));
  },
  boxWrapper: function boxWrapper(t) {
    return css(_templateObject9 || (_templateObject9 = _taggedTemplateLiteralLoose(["\n      position: absolute;\n      box-sizing: border-box;\n      padding: ", ";\n\n      // fix position in ie11\n      display: inline-block;        \n    )};\n    "])), t.checkboxBorderWidth);
  },
  boxWrapperSmall: function boxWrapperSmall(t) {
    return css(_templateObject10 || (_templateObject10 = _taggedTemplateLiteralLoose(["\n      ", ";\n    "])), boxWrapperSizeMixin(t.labGrotesqueBaselineCompensation, t.checkboxFontSizeSmall, t.checkboxBoxSizeSmall, t.checkboxBoxOffsetY, t.checkboxPaddingXSmall));
  },
  boxWrapperMedium: function boxWrapperMedium(t) {
    return css(_templateObject11 || (_templateObject11 = _taggedTemplateLiteralLoose(["\n      ", ";\n    "])), boxWrapperSizeMixin(t.labGrotesqueBaselineCompensation, t.checkboxFontSizeMedium, t.checkboxBoxSizeMedium, t.checkboxBoxOffsetY, t.checkboxPaddingXMedium));
  },
  boxWrapperLarge: function boxWrapperLarge(t) {
    return css(_templateObject12 || (_templateObject12 = _taggedTemplateLiteralLoose(["\n      ", ";\n    "])), boxWrapperSizeMixin(t.labGrotesqueBaselineCompensation, t.checkboxFontSizeLarge, t.checkboxBoxSizeLarge, t.checkboxBoxOffsetY, t.checkboxPaddingXLarge));
  },
  box: function box(t) {
    return css(_templateObject13 || (_templateObject13 = _taggedTemplateLiteralLoose(["\n      color: ", ";\n      box-shadow: ", ";\n      background: ", ";\n      border-radius: ", ";\n      height: 100%;\n    "])), t.checkboxTextColorDefault, t.checkboxShadow, t.checkboxBg, t.checkboxBorderRadius);
  },
  input: function input() {
    return css(_templateObject14 || (_templateObject14 = _taggedTemplateLiteralLoose(["\n      display: inline-block;\n      height: 0;\n      opacity: 0;\n      position: absolute;\n      width: 0;\n      z-index: -1;\n    "])));
  },
  boxWarning: function boxWarning(t) {
    return css(_templateObject15 || (_templateObject15 = _taggedTemplateLiteralLoose(["\n      box-shadow:\n        inset 0 0 0 1px ", ",\n        0 0 0 ", " ", " !important; // override hover and active\n    "])), t.checkboxOutlineColorFocus, t.checkboxOutlineWidth, t.checkboxBorderColorWarning);
  },
  boxError: function boxError(t) {
    return css(_templateObject16 || (_templateObject16 = _taggedTemplateLiteralLoose(["\n      box-shadow:\n        inset 0 0 0 1px ", ",\n        0 0 0 ", " ", " !important; // override hover and active\n    "])), t.checkboxOutlineColorFocus, t.checkboxOutlineWidth, t.checkboxBorderColorError);
  },
  boxChecked: function boxChecked(t) {
    return css(_templateObject17 || (_templateObject17 = _taggedTemplateLiteralLoose(["\n      background: ", ";\n      color: ", ";\n      box-shadow: ", ";\n    "])), t.checkboxCheckedBg, t.checkboxCheckedColor, t.checkboxCheckedShadow);
  },
  boxFocus: function boxFocus(t) {
    return css(_templateObject18 || (_templateObject18 = _taggedTemplateLiteralLoose(["\n      box-shadow:\n        inset 0 0 0 1px ", ",\n        0 0 0 ", " ", " !important; // override hover and active\n    "])), t.checkboxOutlineColorFocus, t.checkboxOutlineWidth, t.checkboxBorderColorFocus);
  },
  boxDisabled: function boxDisabled(t) {
    return css(_templateObject19 || (_templateObject19 = _taggedTemplateLiteralLoose(["\n      box-shadow: ", " !important; // override hover and active\n      background: ", " !important; // override hover and active\n      color: ", ";\n    "])), t.checkboxShadowDisabled, t.checkboxBgDisabled, t.checkboxTextColorDisabled);
  },
  disabled: function disabled(t) {
    return css(_templateObject20 || (_templateObject20 = _taggedTemplateLiteralLoose(["\n      color: ", ";\n      cursor: default;\n    "])), t.checkboxTextColorDisabled);
  },
  icon: function icon() {
    return css(_templateObject21 || (_templateObject21 = _taggedTemplateLiteralLoose(["\n      position: absolute;\n      top: 0;\n      bottom: 0;\n      right: 0;\n      left: 0;\n      display: flex;\n      justify-content: center;\n      align-items: center;\n    "])));
  },
  iconUnchecked: function iconUnchecked() {
    return css(_templateObject22 || (_templateObject22 = _taggedTemplateLiteralLoose(["\n      color: transparent;\n    "])));
  },
  caption: function caption(t) {
    return css(_templateObject23 || (_templateObject23 = _taggedTemplateLiteralLoose(["\n      color: ", ";\n      padding-left: ", ";\n    "])), t.checkboxTextColorDefault, t.checkboxCaptionGap);
  },
  captionIE11: function captionIE11() {
    return css(_templateObject24 || (_templateObject24 = _taggedTemplateLiteralLoose(["\n      display: table-cell;\n    "])));
  }
});